<?php
class Llibre{
			// Classe Llibre
			// clLlibre.php
				
			private $_aLlista;
			private $_aAutors;
			private $_inumAutors;
			private $LlibreID;
			
			/*			Mtodes
			 *			Llibre() // Constructor
			 *			__getID()
			 * 			__get($nv)
			 * 			__getCognoms()
			 *			__set($nv,$val)			 			
			 *			afegirLlibre() 
			 *			esborrarLlibre()
			 *			imprimirLlibre()
			 *			actualitzarLlibre()
			 *			llegirLlibre()
			 */	
			 
			 /*
			 	 			  Constructor. 
							  Parametres: Identificador de Llibre,
							  per defecte = 0.
			 */			 
			 
			 function Llibre($iLlibreID=0){
			 
			 					$this->_aLlista = array();
								$this->_aAutors = array();
								$this->_bDirty = False;
								
								if($iLlibreID <> 0){
															 $this->LlibreID = $iLlibreID;
															 $this->cargarLlibre();
								}
			 }

			 /*
			 	 				__getID(). Obt l'identificador de la classe.
			 */			 
			 
			 function __getID(){
			 					return $this->LlibreID;
			 }
			 
			 /*
			 	 				__get($nv). Obte el valor de la llista amb argument $nv.
			 */
			 			 
			 function __get($nv){
			 					if(isset($this->_aLlista[$nv])){
											return $this->_aLlista[$nv];
								}
								else{
										 return false;
								}
			 }

			 /*
			 	 				__getCognoms(). Obt la llista de cognoms dels autors.
			 */
			 			 
			 function __getCognoms(){
			 
			 					$aux = array();
								
							  for($i=1;$i<=$this->_inumAutors;$i++){
													  $x = $this->_aAutors[$i];
      											$oPer = new Persona($x);	
      											$aux[$i] = $oPer->__get('cognom1');		  
 								};
								return $aux;
			 }			 
			 
			 /*
			 	 			 __set($nv,$val). Posa el valor $val a la posici $nv
			 */
			 			 
			 function	 __set($nv,$val){
			 					 $this->_aLlista[$nv] = $val;
								 return True;
			 }

			 /*
			 	 			 afegirLlibre(). Introdueix el Llibre a la base de dades
			 */
			 			 
			 function afegirLlibre(){
			 					$this->UltimaMod = date("Y-m-d H:i:s");
								$this->DataCreacio = date("Y-m-d H:i:s");
								
								$sql = "INSERT INTO llibre ";
								$sql .= "(titol, ISBN, lloc, pagines, volum, any, eds, editorial, web, dc, du) Values ";
  							$sql .= "(\"".$this->_aLlista['titol']."\",\"";
								$sql .= "".$this->_aLlista['ISBN']."\",\"".$this->_aLlista['lloc']."\",\"";
								$sql .= "".$this->_aLlista['pagines']."\",\"".$this->_aLlista['volum']."\",\"";
								$sql .= "".$this->_aLlista['any']."\",\"".$this->_aLlista['eds']."\",\"".$this->_aLlista['editorial']."\",\"";
								$sql .= "".$this->_aLlista['web']."\",\"".$this->DataCreacio."\",\"".$this->UltimaMod."\")";
								$this->LlibreID = realitzarConsulta($sql,"ID");

								return True;
										 	
			 }

			 /*
			 	 			 esborrarLlibre(). Esborra un Llibre de la base de dades			
			 */			 
			 
			 function esborrarLlibre(){
			 					$sql = "DELETE FROM llibre WHERE idllibre = ".$this->LlibreID;
								realitzarConsulta($sql) or die("fall delete Llibre");
			 }


			 /*
			 	 			 imprimirLlibre(). Imprimeix la Llibre en el format de la web 
			 */			 
			 
			 function imprimirLlibre(){
			 					Global $con;
								
								$k1 = "<p align = 'justify'>";
								
                for($i=1;$i<$this->_inumAutors;$i++){
                			  			$x = $this->_aAutors[$i];
                							$oPer = new Persona($x);	
                							$k1 .= $oPer->imprimirPersona_format2().".; ";		  
                };
                
                $x = $this->_aAutors[$this->_inumAutors];
                $oPer = new Persona($x);	
                $k1 .= $oPer->imprimirPersona_format2();
								
								if($this->__get('eds') == 1){
											 		 $k1 .= ". (eds.): ";
								}
								else{
										 			 $k1 .= ".: ";
								}
																
							 if($this->__get('web') == NULL){									
    								$k1 .= "<em> ".$this->__get('titol'). "</em>. ".$this->__get('editorial').", ".$this->__get('volum').". ";
    								$k1 .= $this->__get('lloc').", ".$this->__get('any').". ";
    								$k1 .= "ISBN: ".$this->__get('ISBN');
    					 }else{
							 			$k1 .= "<a href=\"".$this->__get('web')."\">";			
    								$k1 .= "<em> ".$this->__get('titol'). "</em>. ".$this->__get('editorial').", ".$this->__get('volum').". ";
    								$k1 .= $this->__get('lloc').", ".$this->__get('any').". ";
    								$k1 .= "ISBN: ".$this->__get('ISBN')."</a>";
								}
								
								$k1 .= "</p>";
								
								return $k1;    
			 }

			 /*
			 	 			 actualitzarLlibre(). Actualitza un Llibre de la base de dades			
			 */			 
	 
	 		 function actualitzarLlibre(){
			 
			 					Global $con;
								$this->UltimaMod = date("Y-m-d H:i:s");
								
								$sql  = "UPDATE llibre SET ";
								$sql .= "titol = \"".$this->_aLlista['titol']."\", ";
								$sql .= "ISBN = \"".$this->_aLlista['ISBN']."\", ";
								$sql .= "lloc = \"".$this->_aLlista['lloc']."\", "." pagines = \"".$this->_aLlista['pagines']."\", ";
								$sql .= "volum = \"".$this->_aLlista['volum']."\", "." any = \"".$this->_aLlista['any']."\", ";
								$sql .= "editorial = \"".$this->_aLlista['editorial']."\", ";
								$sql .= "du = \"".$this->UltimaMod."\", web = \"".$this->__get('web')."\" ";
								$sql .= "where idllibre = ".$this->LlibreID;
								
								$rst = realitzarConsulta($sql) or die("falla consulta funcio actualitzarLlibre");	
								
								return TRUE;
								
			 }
							

			/*
			 	 			 cargarLlibre(). Privada. Carrega els valor del Llibre amb id a la llista de paramtres.
			 */
								
	 
			 private function cargarLlibre(){
			
							 Global $con;			 			
							 
							 $sql2  =  "SELECT persones.idPersona";
							 $sql2 .= " from persones, llibre, personallibre";
               $sql2 .= " where llibre.idllibre = personallibre.idllibre";
               $sql2 .= " and persones.idpersona = personallibre.idpersona";
					     $sql2 .= " and llibre.idllibre = ".$this->LlibreID ;
							 $sql2 .= " ORDER BY cognom1 ASC";
							 				 			 						 							 
							 $rst2 = realitzarConsulta($sql2) or die("falla consulta funcio llegirLlibre Select Autors --> 1");	 
							 $k1 = 0;
							 
//							 while($fila2 = $rst2->fetch_assoc()){
							
							 while($fila2 = mysql_fetch_assoc($rst2)){
							 
							 							$k1++;
														foreach($fila2 as $col2){
																					 $this->_aAutors[$k1] = $col2;
														}
							 }	
							 
							 $this->_inumAutors = $k1;								 		
							 							 
							 $sql = "select * from llibre where idllibre = ".$this->LlibreID ;							 
							 $rst = realitzarConsulta($sql) or die("falla consulta funcio llegirLlibre Select Llibre");
							 $this->_aLlista = mysql_fetch_assoc($rst);							 
//							 $this->_aLlista = $rst->fetch_assoc();				
							 

			}
			
}
?>